<template>
    <div v-if="isLoading">Loading ......</div>
    <div v-else>
        <div class="search-input">
            <input v-model="searchTerm" type="text" placeholder="Search" @input="filterItems" />
        </div>

        <div class="recipe-cards-list">
            <template v-if="pagedItems.length > 0">
                <RecipeCard v-for="recipe in pagedItems" :key="recipe.id" :recipe-obj="recipe" />
            </template>
            <template v-else>
                <p class="no-recipes-message">No recipes were found for: {{ searchTerm }}</p>
            </template>
        </div>
        <div class="pagination">
            <button :disabled="currentPage === 1" @click="changePage(-1)">Previous</button>
            <span class="page-num">{{ currentPage }}</span>
            <button :disabled="currentPage === totalPages" @click="changePage(1)">Next</button>
        </div>
    </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import RecipeCard from '@/components/recipe-helper/RecipeCard.vue';

export default {
    name: 'RecipesCardsList',
    components: {
        RecipeCard,
    },
    data() {
        return {
            searchTerm: '',
            currentPage: 1,
            pageSize: 9,
            sortOption: 'title',
        };
    },
    computed: {
        ...mapGetters('recipes', ['getItemsList', 'isLoading', 'getFilter']),
        filteredItems() {
            const filter = this.getFilter;
            const searchResults = this.getItemsList.filter((recipe) => {
                return (
                    (!filter.title || (recipe && recipe.title && recipe.title.toLowerCase().includes(filter.title.toLowerCase()))) &&
                    (!filter.description || (recipe && recipe.description && recipe.description.toLowerCase().includes(filter.description.toLowerCase()))) &&
                    (!filter.keywords || (recipe && recipe.keywords && recipe.keywords.some((keyword) => keyword.toLowerCase().includes(filter.keywords.toLowerCase())))) &&
                    (Object.values(recipe || {}).some((value) => {
                        if (typeof value === 'string') {
                            return value.toLowerCase().includes(this.searchTerm.toLowerCase());
                        }
                        return false;
                    }))
                );
            });

            searchResults.sort((a, b) => {
                const aValue = a[this.sortOption].toLowerCase();
                const bValue = b[this.sortOption].toLowerCase();
                return aValue.localeCompare(bValue);
            });
            return searchResults;
        },

        totalPages() {
            return Math.ceil(this.filteredItems.length / this.pageSize);
        },
        pagedItems() {
            const startIndex = (this.currentPage - 1) * this.pageSize;
            const endIndex = startIndex + this.pageSize;
            return this.filteredItems.slice(startIndex, endIndex);
        },
    },
    created() {
        this.loadList()
    },
    methods: {
        ...mapActions('recipes', ['loadList']),
        filterItems() {
            this.currentPage = 1;
        },
        changePage(offset) {
            this.currentPage += offset;
            window.scrollTo({ top: 0, behavior: 'smooth' });
        },
    },

};
</script>

<style lang="scss" scoped>
.search-input {
    padding-left: 10vw;
    padding-right: 10vw;
    font-size: 200%;
    padding-top: 2vh;
    padding-bottom: 2vh;
}

.search-input input {
    width: 100%;
    padding: 10px;
    font-size: 16px;
    border: 2px solid white;
    border-radius: 30px;
    background-color: transparent;
    color: white;
    outline: none;
}

.search-input input::placeholder {
    color: white;
}

.recipe-cards-list {
    display: grid;
    grid-template-columns: repeat(3, minmax(0, 1fr));
    gap: 10vh;
    padding-top: 3vh;
    padding-left: 10vw;
    padding-right: 10vw;
}

.pagination {
    display: flex;
    justify-content: center;
    margin-top: 2vh;

    button {
        background-color: transparent;
        border: 2px solid white;
        cursor: pointer;
        overflow: hidden;
        border-radius: 30px;
        font-size: 100%;
        color: white;
        padding: 10px 20px;
        transition: background-color 0.3s, color 0.3s, border-color 0.3s;
        appearance: none;
        outline: none;
        margin-top: 5px;
    }

    button:hover {
        background-color: white;
        transition: background-color 0.3s, color 0.3s, border-color 0.3s;
        color: green;
        border-color: transparent;
        border: 2px solid white;
    }

    button:disabled {
        opacity: 0.5;
        cursor: not-allowed;
    }

    .page-num {
        font-weight: bold;
        font-size: 100%;
        padding: 1%;
    }
}

.no-recipes-message {
    font-size: 16px;
    color: white;
}
</style>
